<?php

add_filter( 'tc_front_ticket_table_columns', 'tc_print_tickets_frontend', 11, 1 );

function tc_print_tickets_frontend ($fields) {
    $fields[] = array(
        'id' => 'tickets_print_ticket',
        'field_name' => 'tickets_print_ticket',
        'field_title' => __( 'Print', 'tc_print' ),
        'field_type' => 'function',
        'function' => 'tc_print_ticket_action',
        'field_description' => '',
        'post_field_type' => 'post_meta'
    );

    return $fields;
}

function tc_print_ticket_action ($field_name, $field_id, $ticket_id, $return = false) {
    global $tc, $wp;

    $tc_general_settings = get_option( 'tc_general_setting', false );
    $use_order_details_pretty_links = isset( $tc_general_settings[ 'use_order_details_pretty_links' ] ) ? $tc_general_settings[ 'use_order_details_pretty_links' ] : 'yes';

    $ticket = new TC_Ticket( $ticket_id );
    $order = new TC_Order( $ticket->details->post_parent );
    $retrieving_message = __('Loading ticket...', 'tc_print');


    if ( $use_order_details_pretty_links == 'yes' ) {
        $order_key = isset( $wp->query_vars[ 'tc_order_key' ] ) ? sanitize_text_field( $wp->query_vars[ 'tc_order_key' ] ) : strtotime( $order->details->post_date );
        $download_url = apply_filters( 'tc_download_ticket_url_front', wp_nonce_url( trailingslashit( $tc->get_order_slug( true ) ) . $order->details->post_title . '/' . $order_key . '/?download_ticket=' . $ticket_id . '&order_key=' . $order_key, 'download_ticket_' . $ticket_id . '_' . $order_key, 'download_ticket_nonce' ), $order_key, $ticket_id );

        if ( $return ) {
            return '<a class="tc-print-ticket" onclick="printJS({printable:\'' . esc_url( $download_url ) . '.pdf\', type:\'pdf\', showModal:true, modalMessage:\'' . esc_js($retrieving_message) . '\'})">' . '<span class="dashicons dashicons-printer"></span>' . '</a>';
        } else {
            echo '<a class="tc-print-ticket" onclick="printJS({printable:\'' . esc_url( $download_url ) . '.pdf\', type:\'pdf\', showModal:true, modalMessage:\'' . esc_js($retrieving_message) . '\'})">' . '<span class="dashicons dashicons-printer"></span>' . '</a>';
        }

    } else {

        $order_key = isset( $_GET[ 'tc_order_key' ] ) ? sanitize_key( $_GET[ 'tc_order_key' ] ) : strtotime( $order->details->post_date );
        $download_url = str_replace( ' ', '', apply_filters( 'tc_download_ticket_url_front', wp_nonce_url( trailingslashit( $tc->get_order_slug( true ) ) . '?tc_order=' . $order->details->post_title . '&tc_order_key=' . $order_key . '&download_ticket=' . $ticket_id . '&order_key=' . $order_key, 'download_ticket_' . $ticket_id . '_' . $order_key, 'download_ticket_nonce' ), $order_key, $ticket_id ) );

        if ( $return ) {
            return '<a class="tc-print-ticket" onclick="printJS({printable:\'' . esc_url( $download_url ) . '.pdf\', type:\'pdf\', showModal:true, modalMessage:\'' . esc_js($retrieving_message) . '\'})">' . '<span class="dashicons dashicons-printer"></span>' . '</a>';
        } else {
            echo '<a class="tc-print-ticket" onclick="printJS({printable:\'' . esc_url( $download_url ) . '.pdf\', type:\'pdf\', showModal:true, modalMessage:\'' . esc_js($retrieving_message) . '\'})">' . '<span class="dashicons dashicons-printer"></span>' . '</a>';
        }
    }
}